import { Metadata, Http } from '@zeedhi/core';
import { Modal, ModalService } from '@zeedhi/common';
import { TekGrid } from '@zeedhi/teknisa-components-common';

export class AFDeliveryLastWeekModalController {
  private aFDeliveryLastWeekModal!: Modal;
  
  private daySelected: string = '';

  public async createAFDeliveryLastWeekModal() {
    this.aFDeliveryLastWeekModal = await ModalService.createFromJson('/modals/aFDeliveryLastWeekModal', true);
  }

  public destroyAFDeliveryLastWeekModal() {
    this.aFDeliveryLastWeekModal?.destroy();
  }

  public async openAFDeliveryLastWeekModal({ component, config }) {
    const gridRoute = component.options.props.gridRoute;
    this.daySelected = component.options.xaxis.categories[config.dataPointIndex];
    await this.aFDeliveryLastWeekModal.show();
    const gridGroup = Metadata.getInstance<TekGrid>('aFDeliveryLastWeekGrid');
    gridGroup.title = `Data Selecionada: ${this.daySelected}`;
    
    let queryString = 'requestType=FilterData';
    queryString += `&SELECTED=${this.daySelected}`;
    
    Http.get(`/${gridRoute}?${queryString}`).then(({ data }) => {
      gridGroup.datasource.updateData(data.dataset.aFDeliveryLastWeekGrid);
    });
  }

  public closeAFDeliveryLastWeekModal() {
    this.aFDeliveryLastWeekModal.hide();
  }
}
